
// pd code: 
// #include "m_pd.h"
#include "ext.h"
#include "math.h"


// pd code: 
// static t_class *iAmbient2D_class;
void *iAmbient2D_class;

typedef struct _iAmbient2D {
  t_object  x_obj;
  t_atom  force[12];
  /*
  force = 
		forceX, 
		forceY, 
		randomFX, 
		randomFY, 
		damp, 
		Xmin, 
		Xmax,
		Ymin,
		Ymax,
		dX,
		dY;
  */


// pd code: 
//   t_outlet *force_new;// outlet
  void *force_new;// outlet
  t_symbol *x_sym;  // send
} t_iAmbient2D;

// function prototypes: 
float atom_getfloatarg(short n, long argc, t_atom *argv);
void iAmbient2D_forceX(t_iAmbient2D *x, double f1);
void iAmbient2D_forceY(t_iAmbient2D *x, double f1);
void iAmbient2D_force(t_iAmbient2D *x, double f1, double f2);
void iAmbient2D_rndFX(t_iAmbient2D *x, double X);
void iAmbient2D_rndFY(t_iAmbient2D *x, double X);
void iAmbient2D_rndF(t_iAmbient2D *x, double f1, double f2);
void iAmbient2D_damp(t_iAmbient2D *x, double X);
void iAmbient2D_Xmin(t_iAmbient2D *x, double Xmin);
void iAmbient2D_Xmax(t_iAmbient2D *x, double Xmax);
void iAmbient2D_Ymin(t_iAmbient2D *x, double Ymin);
void iAmbient2D_Ymax(t_iAmbient2D *x, double Ymax);
void iAmbient2D_dXY(t_iAmbient2D *x, double dX, double dY);
void iAmbient2D_dX(t_iAmbient2D *x, double dX);
void iAmbient2D_dY(t_iAmbient2D *x, double dY);
void iAmbient2D_bang(t_iAmbient2D *x);
void *iAmbient2D_new(t_symbol *s, int argc, t_atom *argv);
// end of function prototypes

//----- added to make the PD atom_getfloatarg work
float atom_getfloatarg(short n, long argc, t_atom *argv)
{
float x = argv[n].a_w.w_float;
return(x);
}
//-----


// pd code: 
// void iAmbient2D_forceX(t_iAmbient2D *x, t_floatarg f1)
void iAmbient2D_forceX(t_iAmbient2D *x, double f1)
{
  SETFLOAT(&(x->force[0]), f1);
}


// pd code: 
// void iAmbient2D_forceY(t_iAmbient2D *x, t_floatarg f1)
void iAmbient2D_forceY(t_iAmbient2D *x, double f1)
{
  SETFLOAT(&(x->force[1]), f1);
}


// pd code: 
// void iAmbient2D_force(t_iAmbient2D *x, t_floatarg f1, t_floatarg f2)
void iAmbient2D_force(t_iAmbient2D *x, double f1, double f2)
{
  SETFLOAT(&(x->force[0]), f1);
  SETFLOAT(&(x->force[1]), f2 );
}


// pd code: 
// void iAmbient2D_rndFX(t_iAmbient2D *x, t_float X)
void iAmbient2D_rndFX(t_iAmbient2D *x, double X)
{
  SETFLOAT(&(x->force[2]), X);
}


// pd code: 
// void iAmbient2D_rndFY(t_iAmbient2D *x, t_float X)
void iAmbient2D_rndFY(t_iAmbient2D *x, double X)
{
  SETFLOAT(&(x->force[3]), X);
}


// pd code: 
// void iAmbient2D_rndF(t_iAmbient2D *x, t_floatarg f1, t_floatarg f2)
void iAmbient2D_rndF(t_iAmbient2D *x, double f1, double f2)
{
  SETFLOAT(&(x->force[2]), f1);
  SETFLOAT(&(x->force[3]), f2);
}


// pd code: 
// void iAmbient2D_damp(t_iAmbient2D *x, t_float X)
void iAmbient2D_damp(t_iAmbient2D *x, double X)
{
  SETFLOAT(&(x->force[4]), X);
}


// pd code: 
// void iAmbient2D_Xmin(t_iAmbient2D *x, t_float Xmin)
void iAmbient2D_Xmin(t_iAmbient2D *x, double Xmin)
{
  SETFLOAT(&(x->force[6]), Xmin);
}


// pd code: 
// void iAmbient2D_Xmax(t_iAmbient2D *x, t_float Xmax)
void iAmbient2D_Xmax(t_iAmbient2D *x, double Xmax)
{
  SETFLOAT(&(x->force[7]), Xmax);
}


// pd code: 
// void iAmbient2D_Ymin(t_iAmbient2D *x, t_float Ymin)
void iAmbient2D_Ymin(t_iAmbient2D *x, double Ymin)
{
  SETFLOAT(&(x->force[8]), Ymin);
}


// pd code: 
// void iAmbient2D_Ymax(t_iAmbient2D *x, t_float Ymax)
void iAmbient2D_Ymax(t_iAmbient2D *x, double Ymax)
{
  SETFLOAT(&(x->force[9]), Ymax);
}


// pd code: 
// void iAmbient2D_dXY(t_iAmbient2D *x, t_float dX, t_float dY)
void iAmbient2D_dXY(t_iAmbient2D *x, double dX, double dY)
{
  SETFLOAT(&(x->force[10]), dX);
  SETFLOAT(&(x->force[11]), dY);
}


// pd code: 
// void iAmbient2D_dX(t_iAmbient2D *x, t_float dX)
void iAmbient2D_dX(t_iAmbient2D *x, double dX)
{
  SETFLOAT(&(x->force[10]), dX);
}


// pd code: 
// void iAmbient2D_dY(t_iAmbient2D *x, t_float dY)
void iAmbient2D_dY(t_iAmbient2D *x, double dY)
{
  SETFLOAT(&(x->force[11]), dY);
}

void iAmbient2D_bang(t_iAmbient2D *x)
{
  // if (x->x_sym->s_thing) typedmess(x->x_sym->s_thing, gensym("interactor_ambient_2D"), 12, x->force);

  outlet_anything(x->force_new, gensym("interactor_ambient_2D"), 12, x->force);
}

void *iAmbient2D_new(t_symbol *s, int argc, t_atom *argv)
{

// pd code: 
//   t_iAmbient2D *x = (t_iAmbient2D *)pd_new(iAmbient2D_class);
  t_iAmbient2D *x = (t_iAmbient2D *)newobject(iAmbient2D_class);

// commented out by hand
//  x->x_sym = atom_getsymbolarg(0, argc, argv);


// pd code: ***UNCHANGED*** 
//   x->force_new=outlet_new(&x->x_obj, 0);
// added by ali
x->force_new=outlet_new(&x->x_obj, 0);



    SETFLOAT(&(x->force[5]), 0);


  if (argc>=12)
    SETFLOAT(&(x->force[11]), atom_getfloatarg(11, argc, argv));
  else
    SETFLOAT(&(x->force[11]), 0);

  if (argc>=11)
    SETFLOAT(&(x->force[10]), atom_getfloatarg(10, argc, argv));
  else
    SETFLOAT(&(x->force[10]), 0);

   if (argc>=10)
    SETFLOAT(&(x->force[9]), atom_getfloatarg(9, argc, argv));
  else
    SETFLOAT(&(x->force[9]), 100000);

  if (argc>=9)
    SETFLOAT(&(x->force[8]), atom_getfloatarg(8, argc, argv));
  else
    SETFLOAT(&(x->force[8]), -100000);

  if (argc>=8)
    SETFLOAT(&(x->force[7]), atom_getfloatarg(7, argc, argv));
  else
    SETFLOAT(&(x->force[7]), 100000);

  if (argc>=7)
    SETFLOAT(&(x->force[6]), atom_getfloatarg(6, argc, argv));
  else
    SETFLOAT(&(x->force[6]), -100000);

    if (argc>=6)
    SETFLOAT(&(x->force[4]), atom_getfloatarg(5, argc, argv));
  else
    SETFLOAT(&(x->force[4]), 0);

  if (argc>=5)
    SETFLOAT(&(x->force[3]), atom_getfloatarg(4, argc, argv));
  else
    SETFLOAT(&(x->force[3]), 0);

  if (argc>=4)
    SETFLOAT(&(x->force[2]), atom_getfloatarg(3, argc, argv));
  else
    SETFLOAT(&(x->force[2]), 0);

  if (argc>=3)
    SETFLOAT(&(x->force[1]), atom_getfloatarg(2, argc, argv));
  else
    SETFLOAT(&(x->force[1]), 0);

  if (argc>=2)
    SETFLOAT(&(x->force[0]), atom_getfloatarg(1, argc, argv));
  else
    SETFLOAT(&(x->force[0]), 0);

  return (x);
}


// pd code: 
// void iAmbient2D_setup(void) 
int main(void)
{
// pd code:
/*  iAmbient2D_class = class_new(gensym("iAmbient2D"),
        (t_newmethod)iAmbient2D_new,
        0, sizeof(t_iAmbient2D),
        CLASS_DEFAULT, A_GIMME, 0);  */
        
// replaced by hand
setup((t_messlist **) & iAmbient2D_class,(method)iAmbient2D_new,0,sizeof(t_iAmbient2D),0L, A_GIMME, 0);

// pd code: 
//   class_addcreator((t_newmethod)iAmbient2D_new, gensym("pmpd.iAmbient2D"), A_GIMME, 0);
  // class_addcreator ((t_newmethod)iAmbient2D_new, gensym("pmpd.iAmbient2D"), A_GIMME, 0);


// pd code: 
//   class_addbang(iAmbient2D_class, iAmbient2D_bang);
addbang((method)iAmbient2D_bang);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_force, gensym("setFXY"), A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)iAmbient2D_force, "setFXY", A_DEFFLOAT, A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_forceX, gensym("setFX"), A_DEFFLOAT, 0);
addmess((method)iAmbient2D_forceX, "setFX", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_forceY, gensym("setFY"), A_DEFFLOAT, 0);
addmess((method)iAmbient2D_forceY, "setFY", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_Xmin, gensym("setXmin"), A_DEFFLOAT, 0);
addmess((method)iAmbient2D_Xmin, "setXmin", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_Ymin, gensym("setYmin"), A_DEFFLOAT, 0);
addmess((method)iAmbient2D_Ymin, "setYmin", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_Xmax, gensym("setXmax"), A_DEFFLOAT, 0);
addmess((method)iAmbient2D_Xmax, "setXmax", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_Ymax, gensym("setYmax"), A_DEFFLOAT, 0);
addmess((method)iAmbient2D_Ymax, "setYmax", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_rndFY, gensym("setRndFY"), A_DEFFLOAT, 0);
addmess((method)iAmbient2D_rndFY, "setRndFY", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_rndFX, gensym("setRndFX"), A_DEFFLOAT, 0);
addmess((method)iAmbient2D_rndFX, "setRndFX", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_damp, gensym("setD"), A_DEFFLOAT, 0);
addmess((method)iAmbient2D_damp, "setD", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_dX, gensym("setdX"), A_DEFFLOAT, 0);
addmess((method)iAmbient2D_dX, "setdX", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_dY, gensym("setdY"), A_DEFFLOAT, 0);
addmess((method)iAmbient2D_dY, "setdY", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iAmbient2D_class, (t_method)iAmbient2D_dXY, gensym("setdXY"), A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)iAmbient2D_dXY, "setdXY", A_DEFFLOAT, A_DEFFLOAT, 0);

return 0;
}
