
// pd code: 
// #include "m_pd.h"
#include "ext.h"
#include "math.h"


// pd code: 
// static t_class *iCircle3D_class;
void *iCircle3D_class;

typedef struct _iCircle3D {
  t_object  x_obj;
  t_atom  force[14];

// pd code: 
//   t_outlet *force_new; // outlet
  void *force_new; // outlet
  t_symbol *x_sym;  // send
 
} t_iCircle3D;

// function prototypes: 
float atom_getfloatarg(short n, long argc, t_atom *argv);
void iCircle3D_bang(t_iCircle3D *x);
void iCircle3D_setXYZ(t_iCircle3D *x, double X, double Y, double Z);
void iCircle3D_setVXYZ(t_iCircle3D *x, double X, double Y, double Z);
void iCircle3D_setVX(t_iCircle3D *x, double X);
void iCircle3D_setVY(t_iCircle3D *x, double Y);
void iCircle3D_setVZ(t_iCircle3D *x, double Z);
void iCircle3D_setX(t_iCircle3D *x, double X);
void iCircle3D_setY(t_iCircle3D *x, double Y);
void iCircle3D_setZ(t_iCircle3D *x, double Z);
void iCircle3D_setRmin(t_iCircle3D *x, double f1);
void iCircle3D_setRmax(t_iCircle3D *x, double f1);
void iCircle3D_setFN(t_iCircle3D *x, double f1);
void iCircle3D_setKN(t_iCircle3D *x, double f1);
void iCircle3D_setD(t_iCircle3D *x, double f1);
void iCircle3D_setPmax(t_iCircle3D *x, double X);
void iCircle3D_setdN(t_iCircle3D *x, double f1);
void iCircle3D_setdKN(t_iCircle3D *x, double X);
void *iCircle3D_new(t_symbol *s, int argc, t_atom *argv);
// end of function prototypes

//----- added to make the PD atom_getfloatarg work
float atom_getfloatarg(short n, long argc, t_atom *argv)
{
float x = argv[n].a_w.w_float;
return(x);
}
//-----

void iCircle3D_bang(t_iCircle3D *x)
{
 // if (x->x_sym->s_thing) typedmess(x->x_sym->s_thing, gensym("interactor_circle_3D"), 14, x->force);

  outlet_anything(x->force_new, gensym("interactor_circle_3D"), 14, x->force);
}


// pd code: 
// void iCircle3D_setXYZ(t_iCircle3D *x, t_float X, t_float Y, t_float Z)
void iCircle3D_setXYZ(t_iCircle3D *x, double X, double Y, double Z)
{
  SETFLOAT(&(x->force[3]), X);
  SETFLOAT(&(x->force[4]), Y);
  SETFLOAT(&(x->force[5]), Z);
}

// pd code: 
// void iCircle3D_setVXYZ(t_iCircle3D *x, t_float X, t_float Y, t_float Z)
void iCircle3D_setVXYZ(t_iCircle3D *x, double X, double Y, double Z)
{
  SETFLOAT(&(x->force[0]), X);
  SETFLOAT(&(x->force[1]), Y);
  SETFLOAT(&(x->force[2]), Z);
}


// pd code: 
// void iCircle3D_setVX(t_iCircle3D *x, t_float X)
void iCircle3D_setVX(t_iCircle3D *x, double X)
{
  SETFLOAT(&(x->force[0]), X);
}


// pd code: 
// void iCircle3D_setVY(t_iCircle3D *x, t_float Y)
void iCircle3D_setVY(t_iCircle3D *x, double Y)
{
  SETFLOAT(&(x->force[1]), Y);
}


// pd code: 
// void iCircle3D_setVZ(t_iCircle3D *x, t_float Z)
void iCircle3D_setVZ(t_iCircle3D *x, double Z)
{
  SETFLOAT(&(x->force[2]), Z);
}

// pd code: 
// void iCircle3D_setX(t_iCircle3D *x, t_float X)
void iCircle3D_setX(t_iCircle3D *x, double X)
{
  SETFLOAT(&(x->force[3]), X);
}


// pd code: 
// void iCircle3D_setY(t_iCircle3D *x, t_float Y)
void iCircle3D_setY(t_iCircle3D *x, double Y)
{
  SETFLOAT(&(x->force[4]), Y);
}


// pd code: 
// void iCircle3D_setZ(t_iCircle3D *x, t_float Z)
void iCircle3D_setZ(t_iCircle3D *x, double Z)
{
  SETFLOAT(&(x->force[5]), Z);
}


// pd code: 
// void iCircle3D_setRmin(t_iCircle3D *x, t_floatarg f1)
void iCircle3D_setRmin(t_iCircle3D *x, double f1)
{
  SETFLOAT(&(x->force[6]), f1);
}


// pd code: 
// void iCircle3D_setRmax(t_iCircle3D *x, t_floatarg f1)
void iCircle3D_setRmax(t_iCircle3D *x, double f1)
{
  SETFLOAT(&(x->force[7]), f1);
}


// pd code: 
// void iCircle3D_setFN(t_iCircle3D *x, t_floatarg f1)
void iCircle3D_setFN(t_iCircle3D *x, double f1)
{
  SETFLOAT(&(x->force[8]), f1);
}


// pd code: 
// void iCircle3D_setKN(t_iCircle3D *x, t_floatarg f1)
void iCircle3D_setKN(t_iCircle3D *x, double f1)
{
  SETFLOAT(&(x->force[9]), f1);
}


// pd code: 
// void iCircle3D_setD(t_iCircle3D *x, t_floatarg f1)
void iCircle3D_setD(t_iCircle3D *x, double f1)
{
  SETFLOAT(&(x->force[10]), f1);
}


// pd code: 
// void iCircle3D_setPmax(t_iCircle3D *x, t_float X)
void iCircle3D_setPmax(t_iCircle3D *x, double X)
{
  SETFLOAT(&(x->force[11]), X);
}


// pd code: 
// void iCircle3D_setdN(t_iCircle3D *x, t_floatarg f1)
void iCircle3D_setdN(t_iCircle3D *x, double f1)
{
  SETFLOAT(&(x->force[12]), f1);
}


// pd code: 
// void iCircle3D_setdKN(t_iCircle3D *x, t_float X)
void iCircle3D_setdKN(t_iCircle3D *x, double X)
{
  SETFLOAT(&(x->force[13]), X);
}

void *iCircle3D_new(t_symbol *s, int argc, t_atom *argv)
{

// pd code: 
//   t_iCircle3D *x = (t_iCircle3D *)pd_new(iCircle3D_class);
  t_iCircle3D *x = (t_iCircle3D *)newobject(iCircle3D_class);

//  x->x_sym = atom_getsymbolarg(0, argc, argv);


// pd code: ***UNCHANGED*** 
//   x->force_new=outlet_new(&x->x_obj, 0);



  if (argc>=15)
    SETFLOAT(&(x->force[13]), atom_getfloatarg(14, argc, argv));
  else
    SETFLOAT(&(x->force[13]), 0);
 
  if (argc>=14)
    SETFLOAT(&(x->force[12]), atom_getfloatarg(13, argc, argv));
  else
    SETFLOAT(&(x->force[12]), 0);
  
  if (argc>=13)
    SETFLOAT(&(x->force[11]), atom_getfloatarg(12, argc, argv));
  else
    SETFLOAT(&(x->force[11]), 10000);
 
  if (argc>=12)
    SETFLOAT(&(x->force[10]), atom_getfloatarg(11, argc, argv));
  else
    SETFLOAT(&(x->force[10]), 0);
  
  if (argc>=11)
    SETFLOAT(&(x->force[9]), atom_getfloatarg(10, argc, argv));
  else
    SETFLOAT(&(x->force[9]), 0);
 
  if (argc>=10)
    SETFLOAT(&(x->force[8]), atom_getfloatarg(9, argc, argv));
  else
    SETFLOAT(&(x->force[8]), 0);

  if (argc>=9)
    SETFLOAT(&(x->force[7]), atom_getfloatarg(8, argc, argv));
  else
    SETFLOAT(&(x->force[7]), 1);

  if (argc>=8)
    SETFLOAT(&(x->force[6]), atom_getfloatarg(7, argc, argv));
  else
    SETFLOAT(&(x->force[6]), 0);

    if (argc>=7)
    SETFLOAT(&(x->force[5]), atom_getfloatarg(6, argc, argv));
  else
    SETFLOAT(&(x->force[5]), 0);

    if (argc>=6)
    SETFLOAT(&(x->force[4]), atom_getfloatarg(5, argc, argv));
  else
    SETFLOAT(&(x->force[4]), 0);

  if (argc>=5)
    SETFLOAT(&(x->force[3]), atom_getfloatarg(4, argc, argv));
  else
    SETFLOAT(&(x->force[3]), 0);

  if (argc>=4)
    SETFLOAT(&(x->force[2]), atom_getfloatarg(3, argc, argv));
  else
	SETFLOAT(&(x->force[2]), 0);

  if (argc>=3)
    SETFLOAT(&(x->force[1]), atom_getfloatarg(2, argc, argv));
  else
    SETFLOAT(&(x->force[1]), 0);

  if (argc>=2)
	 SETFLOAT(&(x->force[0]), atom_getfloatarg(1, argc, argv));
  else
	 SETFLOAT(&(x->force[0]), 1);

  return (x);
}


// pd code: 
// void iCircle3D_setup(void) 
int main(void)
{

// pd code:
/*  iCircle3D_class = class_new(gensym("iCircle3D"),
        (t_newmethod)iCircle3D_new,
        0, sizeof(t_iCircle3D),
        CLASS_DEFAULT, A_GIMME, 0);  */

// added by ali
setup((t_messlist **) & iCircle3D_class,(method)iCircle3D_new,0,sizeof(t_iCircle3D),0L, A_GIMME, 0);

// pd code: 
//   class_addcreator((t_newmethod)iCircle3D_new, gensym("pmpd.iCircle3D"),  A_GIMME, 0);
  // class_addcreator ((t_newmethod)iCircle3D_new, gensym("pmpd.iCircle3D"),  A_GIMME, 0);


// pd code: 
//   class_addbang(iCircle3D_class, iCircle3D_bang);
addbang((method)iCircle3D_bang);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setVX, gensym("setVX"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setVX, "setVX", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setVY, gensym("setVY"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setVY, "setVY", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setVZ, gensym("setVZ"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setVZ, "setVZ", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setX, gensym("setX"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setX, "setX", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setY, gensym("setY"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setY, "setY", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setZ, gensym("setZ"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setZ, "setZ", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setRmin, gensym("setRmin"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setRmin, "setRmin", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setRmax, gensym("setRmax"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setRmax, "setRmax", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setXYZ, gensym("setXYZ"), A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)iCircle3D_setXYZ, "setXYZ", A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setVXYZ, gensym("setVXYZ"), A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)iCircle3D_setVXYZ, "setVXYZ", A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setPmax, gensym("setPmax"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setPmax, "setPmax", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setFN, gensym("setFN"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setFN, "setFN", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setKN, gensym("setKN"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setKN, "setKN", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setdN, gensym("setdN"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setdN, "setdN", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setdKN, gensym("setdKN"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setdKN, "setdKN", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(iCircle3D_class, (t_method)iCircle3D_setD, gensym("setD"), A_DEFFLOAT, 0);
addmess((method)iCircle3D_setD, "setD", A_DEFFLOAT, 0);

return 0;
}
