
// pd code: 
// #include "m_pd.h"
#include "ext.h"
#include "math.h"


// pd code: 
// static t_class *lia2D_class;
void *lia2D_class;

typedef struct _lia2D {
  t_object  x_obj;

// pd code: 
//   t_float raideur, viscosite, D2, longueur, distance_old;
  float raideur, viscosite, D2, longueur, distance_old;

// pd code: 
//   t_float position2Dx1, position2Dx2, posx_old1, posx_old2;
  float position2Dx1, position2Dx2, posx_old1, posx_old2;

// pd code: 
//   t_float position2Dy1, position2Dy2, posy_old1, posy_old2;
  float position2Dy1, position2Dy2, posy_old1, posy_old2;

// pd code: 
//   t_float Lmin, Lmax, muscle;
  float Lmin, Lmax, muscle;

// pd code: 
//   t_outlet *force1;
  void *force1;

// pd code: 
//   t_outlet *force2;
  void *force2;
  
  //proxies added by ali for inlet distinguishing
  void *x_proxy[1];   /* 2 inlets requires 1 proxy */
  long x_inletNumber;  /* where proxy will put inlet number */ 
  
  t_symbol *x_sym;  // receive
} t_lia2D;

// function prototypes: 
float atom_getfloatarg(short n, long argc, t_atom *argv);
void lia2D_position2D(t_lia2D *x, double f1, double f2);
void lia2D_position2D2(t_lia2D *x, double f1, double f2);
void lia2D_bang(t_lia2D *x);
void lia2D_reset(t_lia2D *x);
void lia2D_resetF(t_lia2D *x);
void lia2D_resetL(t_lia2D *x);
void lia2D_setK(t_lia2D *x, double K);
void lia2D_setL(t_lia2D *x, double L);
void lia2D_setD(t_lia2D *x, double D);
void lia2D_setD2(t_lia2D *x, double D);
void lia2D_Lmin(t_lia2D *x, double Lmin);
void lia2D_Lmax(t_lia2D *x, double Lmax);
void lia2D_muscle(t_lia2D *x, double muscle);
void lia2D_free(t_lia2D *x);
void *lia2D_new(t_symbol *s, double l, double K, double D, double D2);
// end of function prototypes

//----- added to make the PD atom_getfloatarg work
float atom_getfloatarg(short n, long argc, t_atom *argv)
{
float x = argv[n].a_w.w_float;
return(x);
}
//-----


// pd code: 
// void lia2D_position2D(t_lia2D *x, t_floatarg f1, t_floatarg f2)
void lia2D_position2D(t_lia2D *x, double f1, double f2)
{
  
  if ((int)proxy_getinlet((struct object *) x) == 0)
  {
  x->position2Dx1 = f1;
  x->position2Dy1 = f2;
  // post("setting position 1: %f %f", f1, f2);
  }
  else
  {
  x->position2Dx2 = f1;
  x->position2Dy2 = f2;
  // post("setting position 2: %f %f", f1, f2);
  }
}


// pd code: 
// void lia2D_position2D2(t_lia2D *x, t_floatarg f1, t_floatarg f2)
void lia2D_position2D2(t_lia2D *x, double f1, double f2)
{
  x->position2Dx2 = f1;
  x->position2Dy2 = f2;
  // post("setting position 2: %f %f", f1, f2);
}

void lia2D_bang(t_lia2D *x)
{

// pd code: 
//   t_float force, force2, forcex1, forcey1, forcex2, forcey2, distance;
  float force, force2, forcex1, forcey1, forcex2, forcey2, distance;
  t_atom force1[2];

  distance = sqrt ( pow((x->position2Dx2-x->position2Dx1), 2) + pow((x->position2Dy2-x->position2Dy1), 2) );

  force = ( x->raideur*(distance-(x->longueur * x->muscle)) ) + (  x->viscosite*(distance-x->distance_old) );

  if (distance > x->Lmax) force=0;
  if (distance < x->Lmin) force=0;

  if (distance != 0)
  {
    forcex1 = force * (x->position2Dx2 - x->position2Dx1) / distance;
    forcey1 = force * (x->position2Dy2 - x->position2Dy1) / distance;
  }
  else
  {
   forcex1 = 0;
   forcey1 = 0 ;
  }

  forcex2 = -forcex1;
  forcey2 = -forcey1;

  forcex1 += (x->posx_old1 - x->position2Dx1)*x->D2;
  forcey1 += (x->posy_old1 - x->position2Dy1)*x->D2;
 
  forcex2 += (x->posx_old2 - x->position2Dx2)*x->D2;
  forcey2 += (x->posy_old2 - x->position2Dy2)*x->D2;

  SETFLOAT(&(force1[0]), forcex2 );
  SETFLOAT(&(force1[1]), forcey2 );


  outlet_anything(x->force2, gensym("force2D"), 2, force1);

  SETFLOAT(&(force1[0]), forcex1 );
  SETFLOAT(&(force1[1]), forcey1 );


outlet_anything(x->force1, gensym("force2D"), 2, force1);
 
  x->posx_old2 = x->position2Dx2;
  x->posx_old1 = x->position2Dx1;

  x->posy_old2 = x->position2Dy2;
  x->posy_old1 = x->position2Dy1;

  x->distance_old = distance;
}

void lia2D_reset(t_lia2D *x)
{
  x->position2Dx1 = 0;
  x->position2Dx2 = 0;
  x->posx_old1 = 0;
  x->posx_old2 = 0;

  x->position2Dy1 = 0;
  x->position2Dy2 = 0;
  x->posy_old1 = 0;
  x->posy_old2 = 0;

  x->distance_old = x->longueur;
}

void lia2D_resetF(t_lia2D *x)
{

  x->posx_old1 = x->position2Dx1;
  x->posx_old2 = x->position2Dx2;

  x->posy_old1 = x->position2Dy1;
  x->posy_old2 = x->position2Dy2;

  x->distance_old = x->longueur;

}

void lia2D_resetL(t_lia2D *x)
{
  x->longueur = sqrt ( pow((x->position2Dx2-x->position2Dx1), 2) + pow((x->position2Dy2-x->position2Dy1), 2) );
}



// pd code: 
// void lia2D_setK(t_lia2D *x, t_float K)
void lia2D_setK(t_lia2D *x, double K)
{
  x->raideur = K;
}


// pd code: 
// void lia2D_setL(t_lia2D *x, t_float L)
void lia2D_setL(t_lia2D *x, double L)
{
  x->longueur = L;
}


// pd code: 
// void lia2D_setD(t_lia2D *x, t_float D)
void lia2D_setD(t_lia2D *x, double D)
{
  x->viscosite = D;
}


// pd code: 
// void lia2D_setD2(t_lia2D *x, t_float D)
void lia2D_setD2(t_lia2D *x, double D)
{
  x->D2 = D;
}


// pd code: 
// void lia2D_Lmin(t_lia2D *x, t_float Lmin)
void lia2D_Lmin(t_lia2D *x, double Lmin)
{
  x->Lmin = Lmin;
}


// pd code: 
// void lia2D_Lmax(t_lia2D *x, t_float Lmax)
void lia2D_Lmax(t_lia2D *x, double Lmax)
{
  x->Lmax = Lmax;
}


// pd code: 
// void lia2D_muscle(t_lia2D *x, t_float muscle)
void lia2D_muscle(t_lia2D *x, double muscle)
{
  x->muscle = muscle;
}

void lia2D_free(t_lia2D *x)
{
//added by ali for proxies:
	   freeobject(x->x_proxy[0]);
// pd code: 
//     pd_unbind(&x->x_obj.ob_pd, x->x_sym);
    // pb_unbind(&x->x_obj.ob_pd, x->x_sym);
}


// pd code: 
// void *lia2D_new(t_symbol *s, t_floatarg l, t_floatarg K, t_floatarg D, t_floatarg D2)
void *lia2D_new(t_symbol *s, double l, double K, double D, double D2)
{
  

// pd code: 
//   t_lia2D *x = (t_lia2D *)pd_new(lia2D_class);
  t_lia2D *x = (t_lia2D *)newobject(lia2D_class);

// commented by hand
//  x->x_sym = s;
//  pd_bind(&x->x_obj.ob_pd, s);

//changed by hand:
//  inlet_new(&x->x_obj, &x->x_obj.ob_pd, gensym("position2D"), gensym("position2D2"));
// inlet_new(x,0);
// inlet4(x,x, "position2D", "position2D2");
x->x_proxy[0] = proxy_new(x,1,&x->x_inletNumber);  

// pd code: ***UNCHANGED*** 
//   x->force1=outlet_new(&x->x_obj, 0);


// pd code: ***UNCHANGED*** 
//   x->force2=outlet_new(&x->x_obj, 0);

//added by hand
x->force2=outlet_new(&x->x_obj, 0);
x->force1=outlet_new(&x->x_obj, 0);

  x->position2Dx1 = 0;
  x->position2Dx2 = 0;
  x->position2Dy1 = 0;
  x->position2Dy2 = 0;

  x->raideur=K;
  x->viscosite=D;
  x->longueur = l;

  x->D2=D2;

  x->Lmin= 0;
  x->Lmax= 10000;
  x->muscle= 1;

  x->distance_old = x->longueur;

  return (x);
}


// pd code: 
// void lia2D_setup(void) 
int main(void)
{

/* pd code:
  lia2D_class = class_new(gensym("lia2D"),
        (t_newmethod)lia2D_new,
        (t_method)lia2D_free, 
		sizeof(t_lia2D),
        CLASS_DEFAULT, A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
*/
setup((t_messlist **) &   lia2D_class,(method)  lia2D_new,(method)  lia2D_free,sizeof(t_lia2D),0L, A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);


// pd code: 
//   class_addcreator((t_newmethod)lia2D_new, gensym("link2D"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
  // class_addcreator ((t_newmethod)lia2D_new, gensym("link2D"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);

// pd code: 
//   class_addcreator((t_newmethod)lia2D_new, gensym("pmpd.link2D"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);
  // class_addcreator ((t_newmethod)lia2D_new, gensym("pmpd.link2D"), A_DEFSYM, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, A_DEFFLOAT, 0);


// pd code: 
//   class_addbang(lia2D_class, lia2D_bang);
addbang((method)lia2D_bang);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_reset, gensym("reset"), 0);
addmess((method)lia2D_reset, "reset", 0);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_resetL, gensym("resetL"), 0);
addmess((method)lia2D_resetL, "resetL", 0);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_resetF, gensym("resetF"), 0);
addmess((method)lia2D_resetF, "resetF", 0);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_setD, gensym("setD"), A_DEFFLOAT, 0);
addmess((method)lia2D_setD, "setD", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_setD2, gensym("setD2"), A_DEFFLOAT, 0);
addmess((method)lia2D_setD2, "setD2", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_setK, gensym("setK"), A_DEFFLOAT, 0);
addmess((method)lia2D_setK, "setK", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_setL, gensym("setL"), A_DEFFLOAT, 0);
addmess((method)lia2D_setL, "setL", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_Lmin, gensym("setLmin"), A_DEFFLOAT, 0);
addmess((method)lia2D_Lmin, "setLmin", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_Lmax, gensym("setLmax"), A_DEFFLOAT, 0);
addmess((method)lia2D_Lmax, "setLmax", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_muscle, gensym("setM"), A_DEFFLOAT, 0);
addmess((method)lia2D_muscle, "setM", A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_position2D, gensym("position2D"), A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)lia2D_position2D, "position2D", A_DEFFLOAT, A_DEFFLOAT, 0);

// pd code: 
//   class_addmethod(lia2D_class, (t_method)lia2D_position2D2, gensym("position2D2"), A_DEFFLOAT, A_DEFFLOAT, 0);
addmess((method)lia2D_position2D2, "position2D2", A_DEFFLOAT, A_DEFFLOAT, 0);

return 0;
}
